#include "font.h"
#include <stdlib.h>

font_elem font[] = {
#include "font.inc"
};

static int font_size = sizeof(font) / sizeof(font[0]) - 1;
static int font_default;
static int id_to_font[65536];

void init_font(void)
{
  int i;
  int default_index = -1;
  font_default = font[font_size].id;
  for (i = 0; i < font_size; i++)
    if (font[i].id == font_default) default_index = i;
  if (default_index == -1) abort();
  for (i = 0; i < 65536; i++) id_to_font[i] = default_index;
  for (i = 0; i < font_size; i++) id_to_font[font[i].id] = i;
}

font_elem *get_font_elem(int c)
{
  if (c < 0 || c > 65535) return &font[font_default];
  return &font[id_to_font[c]];
}
