/*
ffmpeg -ss 00:56:00 -i Dark\ \(2017\)\ -\ S02E04\ -\ The\ Travelers\ \(1080p\ NF\ WEBRip\ x265\ ImE\).mkv -vf subtitles=Dark\ \(2017\)\ -\ S02E04\ -\ The\ Travelers\ \(1080p\ NF\ WEBRip\ x265\ ImE\).mkv:stream_index=10 -vcodec rawvideo -f rawvideo -pix_fmt rgba -video_size 1920x960 /tmp/video

ffmpeg -ss 00:56:00 -i ~/Downloads/Dark\ \(2017\)\ Season\ 2\ S02\ \(1080p\ NF\ WEBRip\ x265\ HEVC\ 10bit\ EAC3\ 5.1\ German\ ImE\)/Dark\ \(2017\)\ -\ S02E04\ -\ The\ Travelers\ \(1080p\ NF\ WEBRip\ x265\ ImE\).mkv -f s16le -acodec pcm_s16le -ac 2 -ar 48000 /tmp/audio

echo 8372800 > /proc/sys/fs/pipe-max-size

ffmpeg -ss 0:10:0 -copyts -i /tmp/adultere.mkv -ss 0:10:0 -vf subtitles=adultere.srt -vcodec rawvideo -f rawvideo -pix_fmt rgba -y /tmp/video
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>

#include "thread.h"
#include "x.h"
#include "downloader.h"
#include "images.h"
#include "sounds.h"
#include "msg.h"
#include "audio.h"
#include "video.h"
#include "util.h"
#include "ffmpeg.h"
#include "font.h"
#include "text_over.h"
#include "eq.h"
#include "eqgui.h"
#include "conf.h"
#include "help.h"

typedef struct {
  downloader_t *dl;
  int width;
  int height;
} download_video_thread_t;

void *download_video_thread(void *_v)
{
  download_video_thread_t *v = _v;

  while (1) {
    char *video = download_video(v->dl, v->width * v->height * 4);
    if (video == NULL) break;
    put_image(video);
  }

  return 0;
}

typedef struct {
  downloader_t *dl;
} download_audio_thread_t;


void *download_audio_thread(void *_a)
{
  download_audio_thread_t *a = _a;

  while (1) {
    char *audio = download_audio(a->dl, 48000 / 50 * 4);
    if (audio == NULL) break;
    put_sound(audio, 48000 / 50 * 4);
  }

  return 0;
}

void usage(void)
{
  printf("vlb version %s\n", VERSION);
  printf("mandatory options:\n");
  printf("    -v <video file>\n");
  printf("    -w <width>\n");
  printf("    -h <height>\n");
  printf("    -fps <frames per second>\n");
  printf("optional options:\n");
  printf("    -fullscreen\n");
  printf("    -st <subtitle file>\n");
  printf("    -sti <subtitle index>\n");
  printf("        use subtitles, at given index\n");
  printf("    -at <audio track>\n");
  printf("        use given audio track\n");
  printf("    -rt <realtime mode>\n");
  printf("        realtime mode: one of none (default), sched_fifo, busy_wait\n");
  printf("        the best is sched_fifo but you need to be root\n");
  printf("        busy_wait is eating 100%% CPU time but no need for root\n");
  printf("        none is fine if video is smooth (not on my setup)\n");
  printf("    -audio <output device>\n");
  printf("        output device one of:\n");
  printf("            alsa (default)\n");
#ifdef PULSE_AUDIO
  printf("            pulseaudio\n");
#endif
  exit(1);
}

/* TODO: remove this global? */
eq e;

#define MODE_DEFAULT 0
#define MODE_EQ      1
#define MODE_HELP    2

char *curtime_string(uint64_t start_frame, uint64_t current_frame, int time_seek, float fps)
{
  static char r[64];
  int h, m, s;
  start_frame += current_frame;
  if (time_seek < 0 && start_frame < (uint64_t)(-time_seek * fps))
    start_frame = 0;
  else
    start_frame += (uint64_t)(time_seek * fps);
  start_frame /= fps;
  h = start_frame / (60 * 60);
  start_frame %= 60 * 60;
  m = start_frame / 60;
  s = start_frame % 60;
  sprintf(r, "%2.2d:%2.2d:%2.2d", h, m, s);
  return r;
}

int main(int n, char **v)
{
  int i;
  int width = -1;
  int height = -1;
  float fps = -1;
  int fullscreen = 0;
  int rt_mode = RT_NONE;
  char *video_file = NULL;
  char *subtitle_file = NULL;
  int sti = -1;
  int at = -1;
  x_t *x;
  downloader_t *dl;
  video_player_t *vp;
  audio_player_t *ap;
  download_video_thread_t dl_video;
  download_audio_thread_t dl_audio;
  int paused = 0;
  int audio_pipe_read;
  int video_pipe_read;
  int pointer_id;
  int video_pid;
  int audio_pid;
  pthread_t video_dl_t;
  pthread_t audio_dl_t;
  uint64_t t;
  uint64_t start_frame;
  int text_over_id = -1;
  eqgui eg;
  int mode = MODE_DEFAULT;
  int eq_on = 1;
  int audio_output = AUDIO_ALSA;
  int dead_processes = 0;
  int end_id = -1;
  int end_reached = 0;
  int audio_latency = 0;

  for (i = 1; i < n; i++) {
    if (!strcmp(v[i], "-v")) {if(i>n-2)usage();video_file=v[++i];continue;}
    if (!strcmp(v[i], "-w")) {if(i>n-2)usage();width=atoi(v[++i]);continue;}
    if (!strcmp(v[i], "-h")) {if(i>n-2)usage();height=atoi(v[++i]);continue;}
    if (!strcmp(v[i], "-fps")) {if(i>n-2)usage();fps=atof(v[++i]);continue;}
    if (!strcmp(v[i], "-st")) {if(i>n-2)usage();subtitle_file=v[++i];continue;}
    if (!strcmp(v[i], "-sti")) {if(i>n-2)usage();sti=atoi(v[++i]);continue;}
    if (!strcmp(v[i], "-at")) {if(i>n-2)usage();at=atoi(v[++i]);continue;}
    if (!strcmp(v[i], "-fullscreen")) {fullscreen=1;continue;}
    if (!strcmp(v[i], "-rt")) {if(i>n-2)usage(); i++;
      if (!strcmp(v[i], "none"))            rt_mode = RT_NONE;
      else if (!strcmp(v[i], "sched_fifo")) rt_mode = RT_SCHED_FIFO;
      else if (!strcmp(v[i], "busy_wait"))  rt_mode = RT_BUSY_WAIT;
      else { printf("unknow rt mode %s\n", v[i]); return 1; }
      continue;
    }
    if (!strcmp(v[i], "-audio")) {if(i>n-2)usage(); i++;
      if (!strcmp(v[i], "alsa"))            { audio_output = AUDIO_ALSA; continue; }
#ifdef PULSE_AUDIO
      else if (!strcmp(v[i], "pulseaudio")) { audio_output = AUDIO_PULSE_AUDIO; continue; }
#endif
      else { printf("unknow audio output device %s\n", v[i]); return 1; }
    }
    usage();
  }

  if (sti != -1 && subtitle_file == NULL) subtitle_file = video_file;

  if (video_file == NULL) {
    fprintf(stderr, "use -v <video file>\n");
    return 1;
  }
  if (width == -1 || height == -1 || fps == -1) {
    fprintf(stderr, "you must use -w <width> and -h <height> and -fps <fps>\n");
    return 1;
  }

  init_msg();

  do {
    char s[FILENAME_MAX+1];
    char *home = getenv("HOME");
    if (home == NULL) break;
    /* 30 is arbitrary, bigger than strlen("/.vlb.conf") */
    if (strlen(home) > FILENAME_MAX-30) abort();
    sprintf(s, "%s/.vlb.conf", home);
    init_conf(s);
  } while (0);

  init_font();
  init_eq(&e, 48000);
  eqgui_init(&eg);

  new_thread(process_watch, NULL, "process watch");

  video_pid = ffmpeg_video(&video_pipe_read, width, height,
                           video_file, subtitle_file, sti, 0);
  audio_pid = ffmpeg_audio(&audio_pipe_read, video_file, at, 0);

  dl = new_downloader(video_pipe_read, audio_pipe_read);

#if 0
  /* preload a bit */
  for (i = 0; i < 10; i++) {
    char *video = download_video(dl, width * height * 4);
    put_image(video);
    char *audio = download_audio(dl, 48000 / 50 * 4);
    put_sound(audio, 48000 / 50 * 4);
  }
#endif

  x = init_display(width, height, fps, fullscreen, &eg);
  new_thread(xthread, x, "x");
  new_thread(xthread_msg, x, "x msg");
  wait_for_x();

  dl_video.dl = dl;
  dl_video.width = width;
  dl_video.height = height;

  dl_audio.dl = dl;

  video_dl_t = new_thread(download_video_thread, &dl_video, "dl video");
  audio_dl_t = new_thread(download_audio_thread, &dl_audio, "dl audio");

  /* activate equalizer */
  {
    arg_t a;
    a[0].p = &e;
    send_msg(TO_AUDIO, M_SET_EQ, a);
  }

  t = get_time();
  start_frame = 0;
  vp = init_video_player(t, fps, rt_mode);
  if (rt_mode == RT_SCHED_FIFO)
    new_rt_thread(video_player, vp, "video player");
  else
    new_thread(video_player, vp, "video player");

  remove_capabilities();

  ap = init_audio_player(t, audio_output);
  new_thread(audio_player, ap, "audio player");

  /* hide pointer in 500 ms */
  {
    arg_t a;
    pointer_id = new_id();
    a[0].i = pointer_id;
    new_timer(500, TO_APP, M_TIMEOUT, a);
  }

  oclear();
  oprintf("press h for help");
  odelay(2000);
  send_msg(TO_X, M_REDRAW, 0);

  /* start audio and video (a bit hackish to use M_SEEK) */
  send_msg(TO_VIDEO, M_SEEK, 0);
  send_msg(TO_AUDIO, M_SEEK, 0);

  while (1) {
    arg_t a;
    int time_seek = 0;
    do {
      int over_ret;
      int msg_type = get_msg(TO_APP, a);
      printf("got msg %d\n", msg_type);
      switch (msg_type) {
      case M_KEYPRESS: {
        int k = a[0].i;
        if (k == 'q') exit(0);
        if (mode == MODE_EQ) {
          over_ret = eqgui_key_press(&eg, k);
          goto handle_over_ret;
        }
        if (mode == MODE_HELP) {
          over_ret = help_key_press(k);
          goto handle_over_ret;
        }
        switch (k) {
        case ' ': {
          /* space to pause/unpause */
          if (paused) {
            arg_t a;
            uint64_t current_frame = video_current_frame(vp);
            a[0].u = get_time() - current_frame * 1000 / fps;
            //start_frame += current_frame;
            paused = 0;
            send_msg(TO_AUDIO, M_UNPAUSED, a);
            send_msg(TO_VIDEO, M_UNPAUSED, a);
            send_msg(TO_SCREEN_ON, M_UNPAUSED, 0);
            oclear();
          } else {
            paused = 1;
            send_msg(TO_AUDIO, M_PAUSED, 0);
            send_msg(TO_VIDEO, M_PAUSED, 0);
            send_msg(TO_SCREEN_ON, M_PAUSED, 0);
            oclear();
            oprintf("paused [%s]", curtime_string(start_frame, video_current_frame(vp), 0, fps));
            send_msg(TO_X, M_REDRAW, 0);
            text_over_id = new_id();
          }
          break;
        }
        case KEY_LEFT:
          if (paused) break;
          time_seek -= 10;
          oclear();
          oprintf("-10s [%s]\n", curtime_string(start_frame, video_current_frame(vp), time_seek, fps));
          odelay(500);
          send_msg(TO_X, M_REDRAW, 0);
          break;
        case KEY_RIGHT:
          if (paused) break;
          time_seek += 10;
          oclear();
          oprintf("+10s [%s]\n", curtime_string(start_frame, video_current_frame(vp), time_seek, fps));
          odelay(500);
          send_msg(TO_X, M_REDRAW, 0);
          break;
        case KEY_UP:
          if (paused) break;
          a[0].i = 1; send_msg(TO_AUDIO, M_GAIN, a); break;
        case KEY_DOWN:
          if (paused) break;
          a[0].i = -1; send_msg(TO_AUDIO, M_GAIN, a); break;
        case 'E':
          send_msg(TO_X, M_SHOW_POINTER, 0);
          pointer_id = new_id();
          eqgui_enter(&eg);
          send_msg(TO_X, M_REDRAW, 0);
          mode = MODE_EQ;
          break;
        case 'e':
          eq_on = 1 - eq_on;
          if (eq_on) a[0].p = &e; else a[0].p = NULL;
          send_msg(TO_AUDIO, M_SET_EQ, a);
          oclear();
          oprintf(eq_on ? "equalizer on\n" : "equalizer off\n");
          odelay(500);
          send_msg(TO_X, M_REDRAW, 0);
          break;
        case 'f': send_msg(TO_X, M_TOGGLE_FULLSCREEN, 0); break;
        case 'F': send_msg(TO_X, M_SIZE_FROM_VIDEO, 0); break;
        case 'h':
          send_msg(TO_X, M_SHOW_POINTER, 0);
          pointer_id = new_id();
          help_enter();
          send_msg(TO_X, M_REDRAW, 0);
          mode = MODE_HELP;
          break;
        case 'a':
        case 'A':
          audio_latency += k == 'a' ? -100 : 100;
          a[0].i = audio_latency;
          send_msg(TO_AUDIO, M_SET_LATENCY, a);
          oclear();
          oprintf("audio latency %d ms", audio_latency);
          odelay(500);
          send_msg(TO_X, M_REDRAW, 0);
          break;
        }
        break;
      }
      case M_POINTER_CLICK: {
        if (mode == MODE_EQ) {
          over_ret = eqgui_button_press(&eg, a[0].i, a[1].i, a[4].i, a[2].i, a[3].i);
          goto handle_over_ret;
        }
        break;
      }
      case M_POINTER_UNCLICK: {
        if (mode == MODE_EQ) {
          over_ret = eqgui_button_release(&eg, a[0].i, a[1].i, a[4].i, a[2].i, a[3].i);
          goto handle_over_ret;
        }
        break;
      }
      case M_POINTER_MOVE: {
        if (mode == MODE_HELP) break;
        if (mode == MODE_EQ) {
          over_ret = eqgui_pointer_move(&eg, a[0].i, a[1].i, a[2].i, a[3].i);
          goto handle_over_ret;
        }
        send_msg(TO_X, M_SHOW_POINTER, 0);
        pointer_id = new_id();
        a[0].i = pointer_id;
        new_timer(500, TO_APP, M_TIMEOUT, a);
        break;
      }
      case M_TIMEOUT: {
        if (a[0].i == pointer_id) send_msg(TO_X, M_HIDE_POINTER, 0);
        break;
      }
      case M_PROCESS_DIED: {
        if (a[0].i == video_pid) {
          printf("video process %d died status %d\n", a[0].i, a[1].i);
          dead_processes++;
        } else
        if (a[0].i == audio_pid) {
          printf("audio process %d died status %d\n", a[0].i, a[1].i);
          dead_processes++;
        } else
          printf("unknown/old process %d died status %d\n", a[0].i, a[1].i);
        if (dead_processes == 2) {
          arg_t a;
          end_id = new_id();
          a[0].i = end_id;
          send_msg(TO_AUDIO, M_WAITING_END, a);
          send_msg(TO_VIDEO, M_WAITING_END, a);
          end_reached = 0;
        }
        break;
      }
      case M_END_REACHED:
        if (a[0].i == end_id) {
          end_reached++;
          if (end_reached == 2) goto end;
        }
        break;
      case M_TEXT_OVER_ON: text_over_id = a[0].i; break;
      case M_TEXT_OVER_OFF:
        if (a[0].i == text_over_id) {
          oclear();
          send_msg(TO_X, M_REDRAW, 0);
        }
        break;
      default: printf("unhandled message %d\n", msg_type); return 1;
      }

      continue;

handle_over_ret:
      if (over_ret == OVER_QUIT) {
        mode = MODE_DEFAULT;
        pointer_id = new_id();
        a[0].i = pointer_id;
        new_timer(500, TO_APP, M_TIMEOUT, a);
        oclear();
      }
      if (over_ret == OVER_REDRAW || over_ret == OVER_QUIT) send_msg(TO_X, M_REDRAW, 0);

    } while (has_msg(TO_APP));

    /* forward or backward in time */
    if (time_seek) {
      /* pause audio and video */
      send_msg(TO_VIDEO, M_PAUSED, 0);
      send_msg(TO_AUDIO, M_PAUSED, 0);

      /* destroy all what needs to be destroyed */
      kill(video_pid, SIGKILL);
      kill(audio_pid, SIGKILL);
      close(video_pipe_read);
      close(audio_pipe_read);

      /* clear audio and video buffers */
      reset_images();
      reset_sounds();

      /* finish downloaders */
      thread_wait(video_dl_t);
      thread_wait(audio_dl_t);
      delete_downloader(dl);

      /* clear again audio and video buffers */
      reset_images();
      reset_sounds();

      /* and restart all */
      start_frame += video_current_frame(vp);
      if (time_seek < 0 && start_frame < (uint64_t)(-time_seek * fps))
        start_frame = 0;
      else
        start_frame += (uint64_t)(time_seek * fps);
      video_pid = ffmpeg_video(&video_pipe_read, width, height,
                               video_file, subtitle_file, sti, start_frame / fps);
      audio_pid = ffmpeg_audio(&audio_pipe_read, video_file, at, start_frame / fps);

      dl = new_downloader(video_pipe_read, audio_pipe_read);

      dead_processes = 0;

#if 0
      /* preload a bit */
      for (i = 0; i < 10; i++) {
        char *video = download_video(dl, width * height * 4);
        put_image(video);
        char *audio = download_audio(dl, 48000 / 50 * 4);
        put_sound(audio, 48000 / 50 * 4);
      }
#endif

      dl_video.dl = dl;
      dl_audio.dl = dl;
      video_dl_t = new_thread(download_video_thread, &dl_video, "dl video");
      audio_dl_t = new_thread(download_audio_thread, &dl_audio, "dl audio");

      /* inform audio and video of seeking */
      send_msg(TO_VIDEO, M_SEEK, 0);
      send_msg(TO_AUDIO, M_SEEK, 0);
    }
  }

end:
  return 0;
}
