#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct {
  unsigned char c[16];
  int id;
} elem;

char *line(void)
{
  static char l[128];
  int len = 0;
  while (1) {
    int c = getchar();
    if (c == EOF || c == '\n') break;
    l[len] = c;
    len++;
  }
  if (len == 0) return NULL;
  l[len] = 0;
  return l;
}

int h2b(char x)
{
  if (x >= '0' && x <= '9') return x - '0';
  if (x >= 'a' && x <= 'f') return x - 'a' + 10;
  if (x >= 'A' && x <= 'F') return x - 'A' + 10;
  abort();
}

elem *new_char(elem *r, int l)
{
  r = realloc(r, (l+1) * sizeof(elem)); if (r == NULL) abort();
  while (1) {
    char *s = line(); if (s == NULL) abort();
    if (!strncmp(s, "ENCODING", 8)) { r[l].id = atoi(s+9); continue; }
    if (!strncmp(s, "BITMAP", 6)) {
      int i;
      for (i = 0; i < 16; i++) {
        s = line(); if (s == NULL) abort();
        if (!s[0] || !s[1] || s[2]) abort();
        r[l].c[i] = (h2b(s[0]) << 4) | h2b(s[1]);
      }
    }
    if (!strncmp(s, "ENDCHAR", 7)) break;
  }
  return r;
}

int main(void)
{
  FILE *f;
  elem *r = NULL;
  int l = 0;
  int def = 0;
  int i;
  while (1) {
    char *s = line(); if (s == NULL) break;
    if (!strncmp(s, "STARTCHAR", 9)) { r = new_char(r, l); l++; continue; }
    if (!strncmp(s, "DEFAULT_CHAR", 12)) { def = atoi(s+13); continue; }
  }
  f = fopen("font.inc", "w"); if (f == NULL) abort();
  for (i = 0; i < l; i++) {
    int j;
    if (r[i].id < 0 || r[i].id > 65535) abort();
    fprintf(f, "  { c: { ");
    for (j = 0; j < 16; j++) fprintf(f, "0x%x, ", r[i].c[j]);
    fprintf(f, "}, id: %d },\n", r[i].id);
  }
  fprintf(f, "  /* default */ { id: %d }\n", def);
  if (fclose(f)) return 1;
  return 0;
}
