#ifndef _MSG_H_
#define _MSG_H_

/* receivers */
#define TO_APP           0
#define TO_X             1
#define TO_ALSA          2
#define TO_VIDEO         3
#define TO_AUDIO         4
#define TO_X_INTERNAL    5
#define TO_VIDEO_FROM_X  6
#define TO_SCREEN_ON     7
#define TO_X_WAIT        8
#define TO_LAST          8

/* messages */
#define M_SHOW_IMAGE      0    /* a[0].p = buffer */
#define M_KEYPRESS        1    /* a[0].i = key pressed, see x.h for values */
#define M_PAUSED          2    /* no arg */
#define M_UNPAUSED        3    /* a[0].u = new start time */
#define M_PROCESS_DIED    4    /* a[0].i = pid, a[1].i = status */
#define M_HIDE_POINTER    5    /* no arg */
#define M_SHOW_POINTER    6    /* no arg */
#define M_POINTER_MOVE    7    /* 0.i=x 1.i=y 2.i=width 3.i=height */
#define M_POINTER_CLICK   8    /* 0.i=x 1.i=y 2.i=width 3.i=height 4.i=button */
#define M_POINTER_UNCLICK 9    /* 0.i=x 1.i=y 2.i=width 3.i=height 4.i=button */
#define M_TIMEOUT         10   /* a[0].i = id of timer */
#define M_GAIN            11   /* a[0].i = delta gain (dB) */
#define M_SEEK            12   /* no arg */
#define M_TEXT_OVER_ON    13   /* a[0].i = text over ID */
#define M_TEXT_OVER_OFF   14   /* a[0].i = text over ID */
#define M_REDRAW          15   /* no arg */
#define M_SET_EQ          16   /* a[0].p = &eq or NULL */
#define M_TOGGLE_FULLSCREEN 17 /* no arg */
#define M_SIZE_FROM_VIDEO 18   /* no arg */
#define M_CONSUMED        19   /* no arg */
#define M_WAITING_END     20   /* 0.i = wait ID */
#define M_END_REACHED     21   /* 0.i = wait ID */
#define M_SET_LATENCY     22   /* 0.i = latency */

#include <stdint.h>

typedef union {
  int i;
  uint64_t u;
  void *p;
} arg_t[10];

void init_msg(void);
void send_msg(int to, int msg_id, arg_t a);
int get_msg(int to, arg_t a);
int has_msg(int to);

#endif /* _MSG_H_ */
