#include <stdio.h>
#include <stdlib.h>
#include <pulse/simple.h>

void *pulseaudio_open(void)
{
  pa_sample_spec spec;

  spec.format = PA_SAMPLE_S16LE;
  spec.rate = 48000;
  spec.channels = 2;

  pa_simple *p = pa_simple_new(NULL, "vlb", PA_STREAM_PLAYBACK, NULL,
                               "vlb audio", &spec, NULL, NULL, NULL);
  if (p == NULL) { fprintf(stderr, "pa_simple_new fails\n"); exit(1); }
  return p;
}

int pulseaudio_latency(void *_p)
{
  pa_simple *p = _p;
  int err = 0;
  pa_usec_t l = pa_simple_get_latency(p, &err); if (err) { fprintf(stderr, "pa_simple_get_latency fails\n"); exit(1); }
printf("latency %d\n", (int)(l * 48 / 1000));
//return 4000;
  return l * 48 / 1000;
}

void pulseaudio_play(void *_p, char *buf, int size)
{
  pa_simple *p = _p;
  int err;
  if (pa_simple_write(p, buf, size * 2 * 2, &err)) { fprintf(stderr, "pa_simple_write fails\n"); exit(1); }
}

void pulseaudio_drop(void *_p)
{
  pa_simple *p = _p;
  int err;
  if (pa_simple_flush(p, &err)) { fprintf(stderr, "pa_simple_flush fails\n"); exit(1); }
}

void pulseaudio_drain(void *_p)
{
  pa_simple *p = _p;
  int err;
  if (pa_simple_drain(p, &err)) { fprintf(stderr, "pa_simple_drain fails\n"); exit(1); }
}
